// ** class_inhert2.d - last tested with D v1.0
/+
 ' When Inherting Base Class functions that have the function same name
 ' has the Base Class function causes them to remain hidden / uncallable.
 ' ----------------------------------------------------------------------
 ' To Compile:C:\dmd\MKoD_ex>dmd class_inhert2.d
 +/
private import std.stdio;

class A 
{
    void test() { writefln( "A.test() Called."); }
    void test( in int iVal ) { writefln( "A.test( in int iVal=\"%s\" ) Called.", iVal ); }

    void test2( in int iVal ) { writefln( "A.test2( in int iVal=\"%s\" ) Called.", iVal ); }
}

class B : A
{
    /+ 
     ' An alias brings in all the same function-name
     ' (note: that it doesn't matter about the function's 
     ' return-type or types of paramters nor the number of 
     ' parameters) into Class B's namespace.
     +/ 
    alias A.test test;
    void test() { writefln( "B.test() Called."); }

    // Could call B.test() 1st then call A.test() in this case.
    //void test() { writefln( "B.test() Called."); super.test(); }
}

int main( in char[][] args )
{
    B ob = new B();
    
    ob.test( 6 );
    ob.test2( 7 );
    ob.test();

    return 0;

} // end int main( in char[][] )