/+
 ' When Inherting Base Class functions that have the function same name
 ' has the Base Class function causes them to remain hidden / uncallable.
 ' ----------------------------------------------------------------------
 ' To Compile:C:\dmd\MKoD_ex>dmd class_inhert3.d
 +/
private import std.stdio;

/+
 ' Using an interface that has all the [return] function( [parameter(s)] ) 
 ' that'll be shared between the SuperClass (Base) and the SubClass(es) which 
 ' will make up the Derived Class' namespace, will make function overloading 
 ' to work correctly.
 +/ 
interface I
{
    void test();
    void test( in int );
}

class A : I
{
    void test() { writefln( "A.test() Called."); }
    void test( in int iVal ) { writefln( "A.test( in int iVal=\"%s\" ) Called.", iVal ); }

    void test2( in int iVal ) { writefln( "A.test2( in int iVal=\"%s\" ) Called.", iVal ); }
}

class B : A
{
    void test() { writefln( "B.test() Called."); }
}

int main( in char[][] args )
{
    B ob = new B();
    
    ob.test2( 7 );

    // Interfaces can be inherited and functions overridden
    I oib = cast(I) ob;
    oib.test( 6 );
    oib.test();

    return 0;

} // end int main( in char[][] )