/+
 ' isprime.d - last tested with D v1.0
 '
 ' A assembly example for returning whether any  
 ' number between 0 to 4294967295 is prime number.
 +/
module primeutil;

private import std.stdio;

/+
 ' To complie for a testing:
 ' C:\dmd>dmd isprime.d -debug=isprime
 '
 ' To compile a D program that uses isprime.d:
 ' C:\dmd>dmd MySource.d isprime.d
 +/

bool isPrime( in uint uiNum )
{
    uint uiIsPrime = false;
    
    asm
    {
        // load in the uint number to check
        mov   EAX,[ uiNum ];
        
        // 0 and 1 are valid values, 
        // but neither are a prime number.
        mov   EDX,EAX;
        cmp   EDX,1;
        jbe    _notprime;    // if 0 or 1 return false
        
        // since 2 will be used as the divisor below
        cmp   EDX,2;       
        je    _prime;        // if EDX == 2 then goto _prime (true)
        mov   EDX,0;         // reset EDX = 0

        // setup the loop counter
        mov   ECX,EAX;       // ECX = EAX
        shr   ECX,1;         // ECX = ECX / 2
        mov   EBX,2;         // first divisor is EDX = 2

    _next:
        // start block, is EAX divisible by EBX? 
        push  EAX;   
        push  EDX;    
        mov   EDX,0;
        div   EBX;
        cmp   EDX,0;        
        pop   EDX;        
        pop   EAX;
        // end block, is EAX divisible by EBX? 
    
        jz   _notprime;      // if EDX == 0 then (EAX is divisible by EBX) goto _notprime
        inc   EBX;           // next divisor equals EBX = EBX + 1
       
        // start loopd block
        dec   ECX;           // ECX = ECX - 1
        cmp   ECX,0;
        jnz  _next;          // if ECX (counter) <> 0 the loop back to _next
        // end loopd block
        
    _prime: // is a prime, so set EAX to true (1).
        mov   EAX,1;
        jmp   _exit;

    _notprime: // is not a prime, so set EAX to false (0).
        mov   EAX,0;
        jmp   _exit;
    
    _exit:
        mov   [ uiIsPrime ],EAX;
    } 
    
    return ( uiIsPrime == 0U ? false : true );
}    

debug( isprime )
{
int main()
{
    uint uiy = 0U;

    writefln( "All the numbers listed below between 0 to 1000 are Primes!" );

    for ( uint uix = 0U; uix <= 1000U; uix++ )
    {
        if ( isPrime( uix ) == true )
        {
            writef( "%4d, ", uix );
            uiy++;

            if ( ( uiy % 10U ) == 0U )
            {
                uiy = 0U;
                writefln();  
            }
        }
    }

    return 0;
    
} // end int main()
}