// switchcaseMM2.d
// switch...case...default example in D
// 12.Oct.04 Compiled and Tested with dmd v0.102
// 28.Feb.05 Compiled and Tested with dmd v0.114
// 04.Jun.06 Compiled and Tested with dmd v0.160
// 10.Jan.07 Compiled and Tested with dmd v1.0
//
// To Compile: C:\dmd\MKoD_ex>dmd switchcaseMM2.d
private import std.stdio;
private import std.random;
private import std.date;

int main()
{
    enum : ubyte { Black=0, Red=1, Blue=2, Green=3, Brown=4, Yellow=5, Orange=6, Purple=7 }
    
    uint[ 8 ] ubytCtr = 0U; 
    ubyte     ubytRN  = 0U;
    int       ix      = 0;
     
    writefln( "Your M&M (Mars&Mars) candy drops are being made...\n" );
    
    for( ;; )
    {
        // Wanted a better range for gathering a random numbers, and so decided to use 
        // the range from 0 to 255 dividing it by 32, instead of just using 0 to 7. 
        ubytRN = getRandomNumber( 0, 255 ) / 32U;
        
        switch ( ubytRN )
        {
           case Black:  { if ( ubytCtr[ Black  ] < 13 ) { writef( "Black,  " ); ubytCtr[ Black  ]++; } else continue; break; }
           case Red:    { if ( ubytCtr[ Red    ] < 13 ) { writef( "Red,    " ); ubytCtr[ Red    ]++; } else continue; break; }
           case Blue:   { if ( ubytCtr[ Blue   ] < 13 ) { writef( "Blue,   " ); ubytCtr[ Blue   ]++; } else continue; break; }
           case Green:  { if ( ubytCtr[ Green  ] < 13 ) { writef( "Green,  " ); ubytCtr[ Green  ]++; } else continue; break; }
           case Brown:  { if ( ubytCtr[ Brown  ] < 13 ) { writef( "Brown,  " ); ubytCtr[ Brown  ]++; } else continue; break; }
           case Yellow: { if ( ubytCtr[ Yellow ] < 13 ) { writef( "Yellow, " ); ubytCtr[ Yellow ]++; } else continue; break; }
           case Orange: { if ( ubytCtr[ Orange ] < 13 ) { writef( "Orange, " ); ubytCtr[ Orange ]++; } else continue; break; }
           case Purple: { if ( ubytCtr[ Purple ] < 13 ) { writef( "Purple, " ); ubytCtr[ Purple ]++; } else continue; break; }
           default : break;
        }
        
        ix++;
        if ( ix % 10 == 0 ) writefln();
        if ( ix == 56 ) break;
      
    }
    
    writefln( "\n" );
    writefln( "Your bag of 56 M&M's has the following amount in each color:" );
    writefln( "Black=%2d, Red   =%2d, Blue  =%2d, Green =%2d", 
               ubytCtr[ Black ], ubytCtr[ Red ], ubytCtr[ Blue ], ubytCtr[ Green ] );
    writefln( "Brown=%2d, Yellow=%2d, Orange=%2d, Purple=%2d",
               ubytCtr[ Brown ], ubytCtr[ Yellow ], ubytCtr[ Orange ], ubytCtr[ Purple ] );
         
    return 0;
    
} // end int main()

/+
 ' Source        : uint getRandomNumber( in uint = 0x0, in uint = 0xFFFFFFFF )
 ' Author        : David L. 'SpottedTiger' Davis
 ' Date Created  : 12.Oct.04 Compiled and Tested with dmd v0.102
 ' Modified Date : 28.Feb.05 Compiled and Tested with dmd v0.114
 ' Requires      : std.random and std.date
 '
 ' By default, returns a unsigned number between 0 to 4,294,967,295. 
 +/
uint getRandomNumber( in uint uiLowNum = 0x0, in uint uiHighNum = 0xFFFFFFFF )
{
    d_time sysTime;
    uint   uiRandom;
    static uint uiMixNum; 
    
    if ( uiHighNum <= 0 )
        return uiLowNum;
        
    if ( uiLowNum == uiHighNum || uiLowNum > uiHighNum )
        return uiLowNum;
    
    sysTime = std.date.msFromTime( std.date.UTCtoLocalTime( std.date.getUTCtime() ) );
    uiMixNum += sysTime << 5;
    
    std.random.rand_seed( uiMixNum, ( sysTime * SecFromTime( sysTime ) ) - uiMixNum );
    
    uiRandom = ( std.random.rand() % ( uiHighNum - uiLowNum + 1 ) + uiLowNum );
    
    //writefln( "uiLowNum=%12d, uiRandom=%12d, uiHighNum=%12d", 
    //           uiLowNum, uiRandom, uiHighNum );
    
    return uiRandom;
    
} // end uint getRandomNumber( in uint = 0x0, in uint = 0xFFFFFFFF )